<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">

    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/finance/orderconsign";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          labelWidth: 200,
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          searchLabelWidth: 100,
          column: [
            {
              label: "主键ID",
              prop: "id",
              hide: true,
              display: false,
            },
            {
              label: "订单ID",
              prop: "orderId",
              hide: true,
              display: false,
            },
            {
              label: "商品ID",
              prop: "goodsId",
              hide: true,
              display: false,
            },
            {
              label: "进货开始时间",
              prop: "startTime",
              search: true,
              type: 'datetime',
              width: 120,
              format:'yyyy-MM-dd HH:mm:ss',
              valueFormat:'yyyy-MM-dd HH:mm:ss',
              hide: true,
            },
            {
              label: "进货结束时间",
              prop: "endTime",
              search: true,
              width: 120,
              type: 'datetime',
              format:'yyyy-MM-dd HH:mm:ss',
              valueFormat:'yyyy-MM-dd HH:mm:ss',
              hide: true,
            },

            {
              label: "商品名称",
              prop: "goodsName",
              overHidden: true,
            },
            {
              label: "总价格",
              prop: "totalPrice",
            },
            {
              label: "寄售用户ID",
              prop: "consignUserId",
              hide: true,
              display: false,
            },
            {
              label: "支付用户ID",
              prop: "payUserId",
              hide: true,
              display: false,
            },
            {
              label: "寄售用户",
              prop: "consignRealName",
              display: false,
              width: 120,
              search: true
            },
            {
              label: "支付用户",
              prop: "payRealName",
              display: false,
              width: 120,
              search: true
            },
            {
              label: "打款状态",
              prop: "isConfirmDisplayName",
              display: false,
              width: 90,
            },
            {
              label: "打款状态",
              prop: "isConfirmDisplay",
              type: "select",
              dicUrl: "/api/blade-system/dict-biz/dictionary?code=is_confirm",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              dataType: "number",
              search: true,
              hide: true,
              display: false,
              rules: [{
                required: true,
                message: "打款状态",
                trigger: "blur"
              }]
            },
            {
              label: "寄售类型",
              prop: "consignTypeDisplayName",
              display: false,
            },
            {
              label: "寄售类型",
              prop: "consignTypeDisplay",
              type: "select",
              dicUrl: "/api/blade-system/dict-biz/dictionary?code=consign_type",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              dataType: "number",
              search: true,
              hide: true,
              display: false,
              rules: [{
                required: true,
                message: "寄售类型",
                trigger: "blur"
              }]
            },
            {
              label: "抢购价",
              prop: "consignPrice",
            },
            {
              label: "寄售天数",
              prop: "consignDays",
              width: 70,
            },
            {
              label: "数量",
              prop: "totalNum",
              width: 70,
            },
            {
              label: "寄售类型",
              prop: "consignType",
              type: "select",
              dicUrl: "/api/blade-system/dict-biz/dictionary?code=consign_type",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              dataType: "number",
              hide: true,
              rules: [{
                required: true,
                message: "请选择寄售类型",
                trigger: "blur"
              }]
            },
            {
              label: "寄售类型",
              prop: "isConfirm",
              type: "select",
              dicUrl: "/api/blade-system/dict-biz/dictionary?code=is_confirm",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              dataType: "number",
              hide: true,
              rules: [{
                required: true,
                message: "请选择寄售类型",
                trigger: "blur"
              }]
            },
            {
              label: "打款时间",
              prop: "confirmTime",
              width: 140,
              rules: [{
                required: true,
                message: "请输入确认时间",
                trigger: "blur"
              }]
            },
            {
              label: "进货时间",
              prop: "createTime",
              width: 140,
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.orderconsign_add, false),
          viewBtn: this.vaildData(this.permission.orderconsign_view, false),
          // delBtn: this.vaildData(this.permission.orderconsign_delete, false),
          editBtn: this.vaildData(this.permission.orderconsign_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      // rowDel(row) {
      //   this.$confirm("确定将选择数据删除?", {
      //     confirmButtonText: "确定",
      //     cancelButtonText: "取消",
      //     type: "warning"
      //   })
      //     .then(() => {
      //       return remove(row.id);
      //     })
      //     .then(() => {
      //       this.onLoad(this.page);
      //       this.$message({
      //         type: "success",
      //         message: "操作成功!"
      //       });
      //     });
      // },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
